﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class NodeHolder : MonoBehaviour
{
    public LinkedList<DestroyableObject> nodes { get; private set; }

    [SerializeField] private DestroyableObject stackNodeObject = null;

    public void MakeNodes(int numberOfNodes)
    {
        if(nodes == null)
            nodes = new LinkedList<DestroyableObject>();
        for (int i = 0; i < nodes.Count; i++)
        {
            nodes.First.Value.Kill();
            nodes.RemoveFirst();
        }
        // The linked list is now empty
        float nodeHeight = stackNodeObject.gameObject.GetComponent<StackNode>().GetNodeHeight();
        for(int i = 0; i < numberOfNodes; i++)
        {
            DestroyableObject node = Instantiate(stackNodeObject);
            node.transform.parent = gameObject.transform;
            //if(nodeHeight == 0f) nodeHeight = node.gameObject.GetComponent<StackNode>()
            node.transform.localPosition = new Vector3(0f, i * nodeHeight, 0f);
            nodes.AddLast(node);
        }
    }

    public void RemoveBottomNode()
    {
        if (nodes.Count != 0)
        {
            DestroyableObject node = nodes.First.Value;
            nodes.RemoveFirst();
            Destroy(node.gameObject);
        }
    }

    public DestroyableObject GetBottomNode()
    {
        return nodes.First.Value;
    }
}
